package com.persagy.apm.common.context.poems;

import com.persagy.apm.common.context.DefaultAppContext;

/**
 * poems上下文
 *
 * @author lixing
 * @version V1.0 2021/5/19 7:14 下午
 **/
public class PoemsContext {
    /** 线程级的上下文 */
    private static final ThreadLocal<PoemsContextContent> context = new ThreadLocal<>();

    public static void unloadContext() {
        context.remove();
    }

    public static void setContext(String userId, String loginDevice, String pd, String groupCode, String projectId) {
        PoemsContextContent poemsContextContent = getContext();

        poemsContextContent.setUserId(userId);
        poemsContextContent.setLoginDevice(loginDevice);
        poemsContextContent.setPd(pd);
        poemsContextContent.setGroupCode(groupCode);
        poemsContextContent.setProjectId(projectId);
    }

    public static PoemsContextContent getContext() {
        PoemsContextContent poemsContextContent = context.get();
        if (poemsContextContent == null) {
            poemsContextContent = new PoemsContextContent();
            context.set(poemsContextContent);
        }
        return context.get();
    }
}
