package com.persagy.apm.translate.extension;

import com.persagy.apm.translate.model.ITransWrapper;
import org.springframework.cglib.beans.BeanMap;

/**
 * map翻译包装类
 * @author Charlie Yu
 * @Date 2021-03-03
 */
public class BeanTransWrapper implements ITransWrapper{

    /**
     * 源对象
     */
    private Object source;
    /**
     * 目标对象
     */
    private Object target;

    /**
     * 目标对象
     */
    private BeanMap targetMap;

    /**
     * 构造方法
     * @param source　源对象
     * @param target 目标对象
     */
    public BeanTransWrapper(Object source,Object target){
        this.source = source;
        if(target == null){
            target = source;
        }
        this.target = target;
        targetMap = BeanMap.create(target);
    }
    @Override
    public Object getValue(String name) {
        return targetMap.get(name);
    }

    @Override
    public void setValue(String name, Object object) {
        targetMap.put(name,object);
    }

    @Override
    public Object getSource() {
        return source;
    }

    @Override
    public Object getResult() {
        return target;
    }
}
