package com.persagy.apm.translate.service;

import com.persagy.apm.translate.model.ITransWrapper;
import com.persagy.apm.translate.model.TransMeta;

/**
 * 翻译接口
 * @author Charlie Yu
 * @Date 2021-03-03
 */
public interface ITranslateHandle {

	/**
	 * 翻译Map数据
	 * @param wrapper 需要翻译的对象
	 * @return 结果数据
	 */
	ITransWrapper trans(ITransWrapper wrapper);

	/**
	 * 取得翻译元数据
	 * @return 翻译元数据
	 */
	TransMeta getMeta();

	/**
	 * 设置翻译元数据
	 * @param meta 翻译元数据
	 */
	void setMeta(TransMeta meta);
}
